local ArcanumGuildHall = _G['ArcanumGuildHall']

local zo_strformat = zo_strformat

function ArcanumGuildHall:ToggleChangelog(option)
    ArcanumGuildHall_Changelog:ClearAnchors()
    ArcanumGuildHall_Changelog:SetAnchor(CENTER, GuiRoot, CENTER, 0, -120)
    ArcanumGuildHall_Changelog:SetHidden(option)
end

function ArcanumGuildHall:ChangelogScreen()
    if not self.db.showChangelog then
        return
    end
    local changelog = table.concat(ArcanumGuildHall.GetDefaultLocaleString("changelog_message"), "\n")
    changelog = string.gsub(changelog, "%[%*%]", "|t12:12:esoui/art/miscellaneous/bullet.dds|t")
    changelog = string.gsub(changelog, "%[%+%]", "|t12:12:esoui/art/miscellaneous/spinnerplus_up.dds|t")
    changelog = string.gsub(changelog, "%[%-%]", "|t12:12:esoui/art/miscellaneous/spinnerminus_up.dds|t")
    changelog = string.gsub(changelog, "%[%=%]", "|t12:12:esoui/art/miscellaneous/check.dds|t")

    ArcanumGuildHall_Changelog_Title:SetText(zo_strformat(ArcanumGuildHall.GetDefaultLocaleString("CHANGELOG_TITLE"), ArcanumGuildHall.name))
    ArcanumGuildHall_Changelog_About:SetText(zo_strformat(ArcanumGuildHall.GetDefaultLocaleString("CHANGELOG_FROM"), ArcanumGuildHall.version, ArcanumGuildHall.author))
    ArcanumGuildHall_Changelog_Text:SetText(changelog)

    if (self.db.welcomeVersion ~= self.version) then
        ArcanumGuildHall_Changelog:SetHidden(false)
    end

    self.db.welcomeVersion = self.version
end