local ArcanumGuildHall = _G['ArcanumGuildHall']

local res = ArcanumGuildHallMediaRes

local function getEndeavorRewards(index)
    local reward = ""
    for rewardIndex = 1, GetNumTimedActivityRewards(index) do
        local rewardId, quantity = GetTimedActivityRewardInfo(index, rewardIndex)
        local rewardType = GetRewardType(rewardId)
        if rewardType == REWARD_ENTRY_TYPE_ADD_CURRENCY then
            local currencyType = GetAddCurrencyRewardInfo(rewardId)
            local currencyIcon = GetCurrencyLootKeyboardIcon(currencyType)
            reward = string.format("%s+%s |t15:15:%s|t", reward, quantity, currencyIcon)
        end
    end
    return reward
end

local function printEndeavorProgress(index, currentProgress)
    local name = GetTimedActivityName(index)
    local maxProgress = GetTimedActivityMaxProgress(index)
    local reward = getEndeavorRewards(index)
    local messageComplete = ""
    local message
    local color

    if GetTimedActivityType(index) == TIMED_ACTIVITY_TYPE_DAILY then
        color = ArcanumGuildHall.db.endeavorColorDaily
    else
        color = ArcanumGuildHall.db.endeavorColorWeekly
    end

    if ArcanumGuildHall.db.showEndeavorReward == false then
        if currentProgress == maxProgress then
            messageComplete = " " .. res.IconCheck .. reward
        end
    else
        if currentProgress == maxProgress then
            messageComplete = " " .. res.Ccolor10 .. "[" .. res.IconCheck .. reward .. "]"
        end
    end

    if ArcanumGuildHall.db.showEndeavorIcon == false then
        message = color .. name .. " [" .. currentProgress .. "/" .. maxProgress .. "]" .. messageComplete .. "|r"
    else
        message = res.IconAA .. color .. " " .. name .. " [" .. currentProgress .. "/" .. maxProgress .. "]" .. messageComplete .. "|r"
    end

    if ArcanumGuildHall.db.locationEndeavorAlert == 0 then
        CHAT_ROUTER:AddSystemMessage(message)
    else
        ZO_Alert(UI_ALERT_CATEGORY_ALERT, nil, message)
    end
end

function ArcanumGuildHall.EndeavorsUpdate(_, index, _, currentProgress)
    if not ArcanumGuildHall.db.enableEndeavorAlert then
        return
    end

    ArcanumGuildHall.Debounce("EndeavorsUpdate"..index, 500, function()
        printEndeavorProgress(index, currentProgress)
    end)
end
